﻿//---------------------------------------------------------------------------------------------------
// <auto-generated>
//    This code was generated by T4Model template for T4 (https://github.com/linq2db/t4models).
//    Changes to this file may cause incorrect behavior and will be lost if the code is regenerated.
// </auto-generated>
//---------------------------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Linq.Expressions;
using System.Reflection;

using LinqToDB;
using LinqToDB.Common;
using LinqToDB.Data;
using LinqToDB.DataProvider.SqlServer;
using LinqToDB.Extensions;
using LinqToDB.Mapping;

namespace OneAccomplishment.Core.Data
{
	/// <summary>
	/// Database       : OneAccomplishment.SqlDb_DEV
	/// Data Source    : SqlServer\OneAccomplishment
	/// </summary>
	public partial class UnitOfWork : LinqToDB.Data.DataConnection
	{
		public ITable<AuditTrailEntity>             AuditTrails             { get { return this.GetTable<AuditTrailEntity>(); } }
		public ITable<ConfigurationEntity>          Configurations          { get { return this.GetTable<ConfigurationEntity>(); } }
		public ITable<LoginAttemptEntity>           LoginAttempts           { get { return this.GetTable<LoginAttemptEntity>(); } }
		public ITable<LoginEntity>                  Logins                  { get { return this.GetTable<LoginEntity>(); } }
		public ITable<LoginPermissionMappingEntity> LoginPermissionMappings { get { return this.GetTable<LoginPermissionMappingEntity>(); } }
		public ITable<LoginRoleMappingEntity>       LoginRoleMappings       { get { return this.GetTable<LoginRoleMappingEntity>(); } }
		public ITable<PermissionEntity>             Permissions             { get { return this.GetTable<PermissionEntity>(); } }
		public ITable<RoleEntity>                   Roles                   { get { return this.GetTable<RoleEntity>(); } }
		public ITable<RoleMappingEntity>            RoleMappings            { get { return this.GetTable<RoleMappingEntity>(); } }
		public ITable<UserAgentEntity>              UserAgents              { get { return this.GetTable<UserAgentEntity>(); } }

		partial void InitDataContext();

		#region FreeTextTable

		public class FreeTextKey<T>
		{
			public T   Key;
			public int Rank;
		}

		private static MethodInfo _freeTextTableMethod1 = typeof(UnitOfWork).GetMethod("FreeTextTable", new Type[] { typeof(string), typeof(string) });

		[FreeTextTableExpression]
		public ITable<FreeTextKey<TKey>> FreeTextTable<TTable,TKey>(string field, string text)
		{
			return this.GetTable<FreeTextKey<TKey>>(
				this,
				_freeTextTableMethod1,
				field,
				text);
		}

		private static MethodInfo _freeTextTableMethod2 = 
			typeof(UnitOfWork).GetMethods()
				.Where(m => m.Name == "FreeTextTable" &&  m.IsGenericMethod && m.GetParameters().Length == 2)
				.Where(m => m.GetParameters()[0].ParameterType.IsGenericTypeEx() && m.GetParameters()[0].ParameterType.GetGenericTypeDefinition() == typeof(Expression<>))
				.Where(m => m.GetParameters()[1].ParameterType == typeof(string))
				.Single();

		[FreeTextTableExpression]
		public ITable<FreeTextKey<TKey>> FreeTextTable<TTable,TKey>(Expression<Func<TTable,string>> fieldSelector, string text)
		{
			return this.GetTable<FreeTextKey<TKey>>(
				this,
				_freeTextTableMethod2,
				fieldSelector,
				text);
		}

		#endregion
	}

	[Table(Schema="dbo", Name="AuditTrails")]
	public partial class AuditTrailEntity
	{
		[Column(DataType=DataType.Int64),                         PrimaryKey, Identity] public long     AuditId      { get; set; } // bigint
		[Column(DataType=DataType.DateTime),                      NotNull             ] public DateTime AuditDateUtc { get; set; } // datetime
		[Column(DataType=DataType.VarChar,  Length=104),          NotNull             ] public string   Username     { get; set; } // varchar(104)
		[Column(DataType=DataType.VarChar,  Length=45),           NotNull             ] public string   IpAddress    { get; set; } // varchar(45)
		[Column(DataType=DataType.Int64),                         NotNull             ] public long     UserAgentId  { get; set; } // bigint
		[Column(DataType=DataType.VarChar,  Length=256),          NotNull             ] public string   AuditMessage { get; set; } // varchar(256)
		[Column(DataType=DataType.VarChar,  Length=int.MaxValue), NotNull             ] public string   CommandType  { get; set; } // varchar(max)
		[Column(DataType=DataType.NVarChar, Length=int.MaxValue), NotNull             ] public string   Trace        { get; set; } // nvarchar(max)
		[Column(DataType=DataType.Int64),                         NotNull             ] public long     LoginRefId   { get; set; } // bigint

		#region Associations

		/// <summary>
		/// FK_AuditTrails_UserAgents
		/// </summary>
		[Association(ThisKey="UserAgentId", OtherKey="UserAgentId", CanBeNull=false, Relationship=Relationship.ManyToOne, KeyName="FK_AuditTrails_UserAgents", BackReferenceName="AuditTrails")]
		public UserAgentEntity UserAgent { get; set; }

		#endregion
	}

	[Table(Schema="dbo", Name="Configurations")]
	public partial class ConfigurationEntity
	{
		[Column(DataType=LinqToDB.DataType.Int64),               PrimaryKey, Identity] public long   ConfigurationId { get; set; } // bigint
		[Column(DataType=LinqToDB.DataType.VarChar, Length=50),  NotNull             ] public string Name            { get; set; } // varchar(50)
		[Column(DataType=LinqToDB.DataType.VarChar, Length=20),  NotNull             ] public string DataType        { get; set; } // varchar(20)
		[Column(DataType=LinqToDB.DataType.Variant),             NotNull             ] public object Value           { get; set; } // sql_variant
		[Column(DataType=LinqToDB.DataType.VarChar, Length=256), NotNull             ] public string Description     { get; set; } // varchar(256)
	}

	[Table(Schema="dbo", Name="LoginAttempts")]
	public partial class LoginAttemptEntity
	{
		[Column(DataType=DataType.Int64),               PrimaryKey, Identity] public long     LoginAttemptId { get; set; } // bigint
		[Column(DataType=DataType.Int64),               NotNull             ] public long     LoginId        { get; set; } // bigint
		[Column(DataType=DataType.VarChar,  Length=45), NotNull             ] public string   IpAddress      { get; set; } // varchar(45)
		[Column(DataType=DataType.Int32),               NotNull             ] public int      AttemptCount   { get; set; } // int
		[Column(DataType=DataType.DateTime),            NotNull             ] public DateTime LastAttemptUtc { get; set; } // datetime

		#region Associations

		/// <summary>
		/// FK_LoginAttempts_Logins
		/// </summary>
		[Association(ThisKey="LoginId", OtherKey="LoginId", CanBeNull=false, Relationship=Relationship.ManyToOne, KeyName="FK_LoginAttempts_Logins", BackReferenceName="LoginAttempts")]
		public LoginEntity Login { get; set; }

		#endregion
	}

	[Table(Schema="dbo", Name="Logins")]
	public partial class LoginEntity
	{
		[Column(DataType=DataType.Int64),               PrimaryKey, Identity] public long   LoginId  { get; set; } // bigint
		[Column(DataType=DataType.VarChar, Length=104), NotNull             ] public string Username { get; set; } // varchar(104)

		#region Associations

		/// <summary>
		/// FK_LoginAttempts_Logins_BackReference
		/// </summary>
		[Association(ThisKey="LoginId", OtherKey="LoginId", CanBeNull=true, Relationship=Relationship.OneToMany, IsBackReference=true)]
		public IEnumerable<LoginAttemptEntity> LoginAttempts { get; set; }

		/// <summary>
		/// FK_LoginPermissionMappings_Logins_BackReference
		/// </summary>
		[Association(ThisKey="LoginId", OtherKey="LoginId", CanBeNull=true, Relationship=Relationship.OneToMany, IsBackReference=true)]
		public IEnumerable<LoginPermissionMappingEntity> LoginPermissionMappings { get; set; }

		/// <summary>
		/// FK_LoginRoleMappings_Logins_BackReference
		/// </summary>
		[Association(ThisKey="LoginId", OtherKey="LoginId", CanBeNull=true, Relationship=Relationship.OneToMany, IsBackReference=true)]
		public IEnumerable<LoginRoleMappingEntity> LoginRoleMappings { get; set; }

		#endregion
	}

	[Table(Schema="dbo", Name="LoginPermissionMappings")]
	public partial class LoginPermissionMappingEntity
	{
		[Column(DataType=DataType.Int64),   PrimaryKey, Identity] public long LoginRoleMappingId { get; set; } // bigint
		[Column(DataType=DataType.Int64),   NotNull             ] public long LoginId            { get; set; } // bigint
		[Column(DataType=DataType.Int64),   NotNull             ] public long PermissionId       { get; set; } // bigint
		[Column(DataType=DataType.Boolean), NotNull             ] public bool IsGranted          { get; set; } // bit

		#region Associations

		/// <summary>
		/// FK_LoginPermissionMappings_Logins
		/// </summary>
		[Association(ThisKey="LoginId", OtherKey="LoginId", CanBeNull=false, Relationship=Relationship.ManyToOne, KeyName="FK_LoginPermissionMappings_Logins", BackReferenceName="LoginPermissionMappings")]
		public LoginEntity Login { get; set; }

		/// <summary>
		/// FK_LoginPermissionMappings_Permissions
		/// </summary>
		[Association(ThisKey="PermissionId", OtherKey="PermissionId", CanBeNull=false, Relationship=Relationship.ManyToOne, KeyName="FK_LoginPermissionMappings_Permissions", BackReferenceName="LoginPermissionMappings")]
		public PermissionEntity Permission { get; set; }

		#endregion
	}

	[Table(Schema="dbo", Name="LoginRoleMappings")]
	public partial class LoginRoleMappingEntity
	{
		[Column(DataType=DataType.Int64), PrimaryKey, Identity] public long LoginRoleMappingId { get; set; } // bigint
		[Column(DataType=DataType.Int64), NotNull             ] public long LoginId            { get; set; } // bigint
		[Column(DataType=DataType.Int64), NotNull             ] public long RoleId             { get; set; } // bigint

		#region Associations

		/// <summary>
		/// FK_LoginRoleMappings_Logins
		/// </summary>
		[Association(ThisKey="LoginId", OtherKey="LoginId", CanBeNull=false, Relationship=Relationship.ManyToOne, KeyName="FK_LoginRoleMappings_Logins", BackReferenceName="LoginRoleMappings")]
		public LoginEntity Login { get; set; }

		/// <summary>
		/// FK_LoginRoleMappings_Roles
		/// </summary>
		[Association(ThisKey="RoleId", OtherKey="RoleId", CanBeNull=false, Relationship=Relationship.ManyToOne, KeyName="FK_LoginRoleMappings_Roles", BackReferenceName="LoginRoleMappings")]
		public RoleEntity Role { get; set; }

		#endregion
	}

	[Table(Schema="dbo", Name="Permissions")]
	public partial class PermissionEntity
	{
		[Column(DataType=DataType.Int64),               PrimaryKey, Identity] public long   PermissionId   { get; set; } // bigint
		[Column(DataType=DataType.VarChar, Length=50),  NotNull             ] public string PermissionName { get; set; } // varchar(50)
		[Column(DataType=DataType.VarChar, Length=50),  NotNull             ] public string Category       { get; set; } // varchar(50)
		[Column(DataType=DataType.VarChar, Length=256), NotNull             ] public string Description    { get; set; } // varchar(256)

		#region Associations

		/// <summary>
		/// FK_LoginPermissionMappings_Permissions_BackReference
		/// </summary>
		[Association(ThisKey="PermissionId", OtherKey="PermissionId", CanBeNull=true, Relationship=Relationship.OneToMany, IsBackReference=true)]
		public IEnumerable<LoginPermissionMappingEntity> LoginPermissionMappings { get; set; }

		/// <summary>
		/// FK_RoleMappings_Permissions_BackReference
		/// </summary>
		[Association(ThisKey="PermissionId", OtherKey="PermissionId", CanBeNull=true, Relationship=Relationship.OneToMany, IsBackReference=true)]
		public IEnumerable<RoleMappingEntity> RoleMappings { get; set; }

		#endregion
	}

	[Table(Schema="dbo", Name="Roles")]
	public partial class RoleEntity
	{
		[Column(DataType=DataType.Int64),               PrimaryKey, Identity] public long   RoleId      { get; set; } // bigint
		[Column(DataType=DataType.VarChar, Length=50),  NotNull             ] public string RoleName    { get; set; } // varchar(50)
		[Column(DataType=DataType.Boolean),             NotNull             ] public bool   IsBuiltIn   { get; set; } // bit
		[Column(DataType=DataType.VarChar, Length=256), NotNull             ] public string Description { get; set; } // varchar(256)

		#region Associations

		/// <summary>
		/// FK_LoginRoleMappings_Roles_BackReference
		/// </summary>
		[Association(ThisKey="RoleId", OtherKey="RoleId", CanBeNull=true, Relationship=Relationship.OneToMany, IsBackReference=true)]
		public IEnumerable<LoginRoleMappingEntity> LoginRoleMappings { get; set; }

		/// <summary>
		/// FK_RoleMappings_Roles_BackReference
		/// </summary>
		[Association(ThisKey="RoleId", OtherKey="RoleId", CanBeNull=true, Relationship=Relationship.OneToMany, IsBackReference=true)]
		public IEnumerable<RoleMappingEntity> RoleMappings { get; set; }

		#endregion
	}

	[Table(Schema="dbo", Name="RoleMappings")]
	public partial class RoleMappingEntity
	{
		[Column(DataType=DataType.Int64), PrimaryKey, Identity] public long RoleMappingId { get; set; } // bigint
		[Column(DataType=DataType.Int64), NotNull             ] public long RoleId        { get; set; } // bigint
		[Column(DataType=DataType.Int64), NotNull             ] public long PermissionId  { get; set; } // bigint

		#region Associations

		/// <summary>
		/// FK_RoleMappings_Permissions
		/// </summary>
		[Association(ThisKey="PermissionId", OtherKey="PermissionId", CanBeNull=false, Relationship=Relationship.ManyToOne, KeyName="FK_RoleMappings_Permissions", BackReferenceName="RoleMappings")]
		public PermissionEntity Permission { get; set; }

		/// <summary>
		/// FK_RoleMappings_Roles
		/// </summary>
		[Association(ThisKey="RoleId", OtherKey="RoleId", CanBeNull=false, Relationship=Relationship.ManyToOne, KeyName="FK_RoleMappings_Roles", BackReferenceName="RoleMappings")]
		public RoleEntity Role { get; set; }

		#endregion
	}

	[Table(Schema="dbo", Name="UserAgents")]
	public partial class UserAgentEntity
	{
		[Column(DataType=DataType.Int64),                                                    PrimaryKey, Identity] public long   UserAgentId { get; set; } // bigint
		[Column(DataType=DataType.VarChar, Length=int.MaxValue),                             NotNull             ] public string UAString    { get; set; } // varchar(max)
		[Column(DataType=DataType.Binary,  Length=20, SkipOnInsert=true, SkipOnUpdate=true), NotNull             ] public byte[] HashedValue { get; set; } // binary(20)

		#region Associations

		/// <summary>
		/// FK_AuditTrails_UserAgents_BackReference
		/// </summary>
		[Association(ThisKey="UserAgentId", OtherKey="UserAgentId", CanBeNull=true, Relationship=Relationship.OneToMany, IsBackReference=true)]
		public IEnumerable<AuditTrailEntity> AuditTrails { get; set; }

		#endregion
	}

	public static partial class UnitOfWorkStoredProcedures
	{
		#region UtilitiesGetHashedString

		public static int UtilitiesGetHashedString(this DataConnection dataConnection, string @StringToHash, ref byte[] @HashedValue)
		{
			var ret = dataConnection.ExecuteProc("[dbo].[Utilities_GetHashedString]",
				new DataParameter("@StringToHash", @StringToHash, DataType.VarChar),
				new DataParameter("@HashedValue",  @HashedValue,  DataType.Binary)  { Direction = ParameterDirection.InputOutput, Size = 20 });

			@HashedValue = Converter.ChangeTypeTo<byte[]>(((IDbDataParameter)dataConnection.Command.Parameters["@HashedValue"]).Value);

			return ret;
		}

		#endregion

		#region ConfigurationsGetValues

		public static IEnumerable<ConfigurationsGetValuesResult> ConfigurationsGetValues(this DataConnection dataConnection)
		{
			return dataConnection.QueryProc<ConfigurationsGetValuesResult>("[dbo].[Configurations_GetValues]");
		}

		public partial class ConfigurationsGetValuesResult
		{
			public int?    LoginAttemptExceededTimeout   { get; set; }
			public int?    LoginAttemptMaxLimit          { get; set; }
			public double? StayLoggedInDefaultDuration   { get; set; }
			public double? StayLoggedInMaxDuration       { get; set; }
			public string  TempDataCorrelationCookieName { get; set; }
			public string  TempDataCorrelationFormName   { get; set; }
			public string  TempDataCorrelationParamName  { get; set; }
		}

		#endregion
	}

	public static partial class TableExtensions
	{
		public static AuditTrailEntity Find(this ITable<AuditTrailEntity> table, long AuditId)
		{
			return table.FirstOrDefault(t =>
				t.AuditId == AuditId);
		}

		public static ConfigurationEntity Find(this ITable<ConfigurationEntity> table, long ConfigurationId)
		{
			return table.FirstOrDefault(t =>
				t.ConfigurationId == ConfigurationId);
		}

		public static LoginAttemptEntity Find(this ITable<LoginAttemptEntity> table, long LoginAttemptId)
		{
			return table.FirstOrDefault(t =>
				t.LoginAttemptId == LoginAttemptId);
		}

		public static LoginEntity Find(this ITable<LoginEntity> table, long LoginId)
		{
			return table.FirstOrDefault(t =>
				t.LoginId == LoginId);
		}

		public static LoginPermissionMappingEntity Find(this ITable<LoginPermissionMappingEntity> table, long LoginRoleMappingId)
		{
			return table.FirstOrDefault(t =>
				t.LoginRoleMappingId == LoginRoleMappingId);
		}

		public static LoginRoleMappingEntity Find(this ITable<LoginRoleMappingEntity> table, long LoginRoleMappingId)
		{
			return table.FirstOrDefault(t =>
				t.LoginRoleMappingId == LoginRoleMappingId);
		}

		public static PermissionEntity Find(this ITable<PermissionEntity> table, long PermissionId)
		{
			return table.FirstOrDefault(t =>
				t.PermissionId == PermissionId);
		}

		public static RoleEntity Find(this ITable<RoleEntity> table, long RoleId)
		{
			return table.FirstOrDefault(t =>
				t.RoleId == RoleId);
		}

		public static RoleMappingEntity Find(this ITable<RoleMappingEntity> table, long RoleMappingId)
		{
			return table.FirstOrDefault(t =>
				t.RoleMappingId == RoleMappingId);
		}

		public static UserAgentEntity Find(this ITable<UserAgentEntity> table, long UserAgentId)
		{
			return table.FirstOrDefault(t =>
				t.UserAgentId == UserAgentId);
		}
	}
}
